/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 539 $ $LastChangedDate: 2002-08-25 13:25:13 +0200 (Sun, 25 Aug 2002) $
 *
 * Module - Module save/restore and symbol lookup. 
 */

open Ast;

struct module {
	id mod_name;
	bool mod_under_construction;
	<var_symbol>Hashtbl::t mod_vars;
	<sf_symbol>Hashtbl::t mod_struct_fields;
	<ty_symbol>Hashtbl::t mod_tydefs;
	<id>List::t mod_depends_on;
}

module open_module(id name);
void save_module(module m, string filename);

ty_symbol lookup_tysym(id module, id name);
var_symbol lookup_var(id module, id name);
<sf_symbol>List::t lookup_struct_field(id module, id name);
void add_to_search_path(string dir);
